#include <esp_now.h>
#include <esp_wifi.h>

#include <Arduino.h>
#include <TM1637Display.h>

#include <WiFi.h>
#include <time.h>
#include <Servo.h>

uint8_t broadcastAddress[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

Servo myservo[3];
int servoPin[] = {25, 26, 27};
int sensorPin[] = {33, 34, 35}; 
int sensorValue[] = {0, 0, 0}; 
int count[] = {0, 0, 0};
int count1 = 0;

int a = 0;

typedef struct test_struct {
  int alarm_sender;
  int alarm_receive;
} test_struct;

void OnDataRecv(const uint8_t * mac, const uint8_t *data, int len) {
   
  test_struct* test =(test_struct*) data;
   
  Serial.println(test->alarm_sender);

  if (test->alarm_sender == 1)
  {
    a = 22;
  }
}

void sender_alarm()
{ 
  test_struct test;
  test.alarm_receive = 2;
  test.alarm_sender = 0;
 
  esp_err_t result = esp_now_send(
    broadcastAddress, 
    (uint8_t *) &test,
    sizeof(test_struct));

  if (result == ESP_OK) {
  Serial.println("Sent with success");
    }
  else {
    Serial.println("Error sending the data");
  }
  
}

   
void setup() 
{ 
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);

  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }

  // register peer
  esp_now_peer_info_t peerInfo;
  
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 6;  
  peerInfo.encrypt = false;
          
  if (esp_now_add_peer(&peerInfo) != ESP_OK){
    Serial.println("Failed to add peer");
    return;
  }
  
  for(int i=0; i<3; i++) {
  myservo[i].attach(servoPin[i]); 
  myservo[i].write(180);   
  }
} 

void loop() 
{ 
  esp_now_register_recv_cb(OnDataRecv);
  for(int i=0; i<3; i++){
    sensorValue[i] = analogRead(sensorPin[i]);
    Serial.print("Sensor");
    Serial.print(i+1);
    Serial.print(" : ");
    Serial.println(sensorValue[i]);
  } 
  
  if (count1 == 0 && a == 22) {
    for(int i=0; i<3; i++) {
      myservo[i].attach(servoPin[i]); 
      myservo[i].write(90);   
     }
     count1 = 1;
  }
  

  if (a == 22) {
      if(sensorValue[0] > 2500 && count[0] != 1){
        myservo[0].write(180);
        count[0] = 1;
  }
      if(sensorValue[1] > 2500 && count[1] != 1){
        myservo[1].write(180);
        count[1] = 1;
  }
      if(sensorValue[2] > 2500 && count[2] != 1){
        myservo[2].write(180);
        count[2] = 1;
  }
     
  delay(500); 
  Serial.print("================\n");
  }
  if (count[0]==1 && count[1]==1 && count[2]==1) {
    sender_alarm();
  }
}
